#include <stdio.h>


#define MAXX 12
#define MAXY 12
#define MAXD ((1<<12)+100)

typedef long long BIG;

BIG ncomb[MAXY][MAXD];
int x, y;
BIG P;


void read_all(void);
void do_all(void);
BIG getn(int y, int d);
void makerow(int ind, int y, BIG *pres, int row0, int row1);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}


void read_all(void)
{
  FILE *f = fopen("build.inp", "rt");
  fscanf(f, "%d %d", &x, &y);
  fclose(f);
}


void do_all(void)
{
  int i, j;

  if ((x*y)%2 == 1)  return;
  for (i = 0; i < MAXY; i++)
    for (j = 0; j < MAXD; j++)  ncomb[i][j] = -1;
  P = getn(y, 1<<x);
}


BIG getn(int y, int d)
{
  int i;
  int row0, row1;
  BIG res = 0;

  if (ncomb[y][d] >= 0)  return ncomb[y][d];
  row0 = d | (1<<x);
  row1 = 1<<x;
  if (y == 0) {
    return ncomb[y][d] = 1;
  }
  if (y == 1) {
    int k;
    for (i = 0, k = 0; i <= x; i++) {
      if ((row0>>i)&1 == 0)  k++;
      else {
        if (k%2 == 1)  break;
        k = 0;
      }
    }
    if (i > x)  return 1;
    return 0;
  }
  for (i = 0; i < x; i++)  if (((row0>>i)&1) == 0)  break;
  makerow(i, y-1, &res, row0, row1);
  return ncomb[y][d] = res;
}


void makerow(int ind, int y, BIG *pres, int row0, int row1)
{
  int i, m = 0;

  if (ind == x) {
    int d, k;
    d = row1;
    if (y == 3) {
      y--;y++;
    }
    for (i = 0, k = 0; i < x; i++)  if ((row1>>i)&1 == 1)  k++;
    if (k == x)  y--, d = 1<<x;
    *pres += getn(y, d);
    return;
  }
    if (((row0>>ind)&1) == 0 && ((row1>>ind)&1) == 0) {
      m++;
      row0 |= 1<<ind;
      row1 |= 1<<ind;
      makerow(ind+1, y, pres, row0, row1);
      row0 &= ~(1<<ind);
      row1 &= ~(1<<ind);
    }
    if (((row0>>ind)&1) == 0 && ((row0>>(ind+1))&1) == 0) {
      m++;
      row0 |= 1<<ind;
      row0 |= 1<<(ind+1);
      makerow(ind+2, y, pres, row0, row1);
      row0 &= ~(1<<ind);
      row0 &= ~(1<<(ind+1));
    }
    if (((row0>>ind)&1) == 1)
      makerow(ind+1, y, pres, row0, row1);
}



void write_all(void)
{
  FILE *f = fopen("build.out", "wt");
  fprintf(f, "%lld\n", P);
  fclose(f);
}



