#include <stdio.h>


#define MAXN 190

int N;
int g[MAXN][MAXN];
int g1[MAXN][MAXN];
int deg[MAXN];
int ind[MAXN], ind_rev[MAXN];
int par[MAXN];
int hiwater[MAXN];
int nind;


void read_all(void);
void do_all(void);
void DFS(int u);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}


void read_all(void)
{
  int i, j;

  FILE *f = fopen("routes.inp", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) {
    fscanf(f, "%d", &deg[i]);
    for (j = 0; j < deg[i]; j++) {
      fscanf(f, "%d", &g[i][j]);  g[i][j]--;
    }
  }
  fclose(f);
}


void do_all(void)
{
  int i, j;
  int arr[5];
  int conto[MAXN]={0};

  if (N == 2) {
    g1[0][1] = g1[1][0] = 2;
    return;
  }
  for (i = 0; i < N; i++)  if (deg[i] < N-1)  break;
  if (i >= N)  return;
  arr[0] = i;
  for (j = 0; j < deg[i]; j++)  conto[g[i][j]] = 1;
  conto[i] = 1;
  for (j = 0; j < N; j++)  if (conto[j] == 0)  break;
  if (j >= N)  return;
  arr[1] = j;
  for (j = 0; j < 2; j++) {
    nind = 0;
    memset(ind, -1, sizeof(ind));
    memset(par, -1, sizeof(par));
    memset(hiwater, -1, sizeof(hiwater));
    DFS(arr[j]);
    for (i = 0; i < N; i++) {
      if (hiwater[i] == ind[i]) {
        g1[i][par[i]]++;
        g1[par[i]][i]++;
      }
    }
  }
}


void DFS(int u)
{
  int i;

  ind[u] = hiwater[u] = nind++;
  ind_rev[ind[u]] = u;
  for (i = 0; i < deg[u]; i++) {
    if (g[u][i] == par[u])  continue;
    if (ind[g[u][i]] == -1) {
      par[g[u][i]] = u;
      DFS(g[u][i]);
      if (hiwater[g[u][i]] < hiwater[u]) {
        hiwater[u] = hiwater[g[u][i]];
      }
    }
    else {
      if (ind[g[u][i]] < hiwater[u]) {
        hiwater[u] = ind[g[u][i]];
      }
    }
  }
}


void write_all(void)
{
  int i, j;

  FILE *f = fopen("routes.out", "wt");
  for (i = 0; i < N; i++) {
    for (j = i+1; j < N; j++) {
      if (g1[i][j] == 2)  fprintf(f, "%d %d\n", i+1, j+1);
    }
  }
  fclose(f);
}



