#include <stdio.h>
#include <math.h>


#undef abs
#undef max
#undef min

typedef struct Tower {
        float x, y, r, a, c1, c2;
        int i;
} TTower;

FILE *fin, *fout;
TTower ts[1000];
int ct;

int cmptwrx(TTower *t1, TTower *t2) {
    if ( t1->x < t2->x )
       return -1;
    if ( t1->x > t2->x )
       return 1;
    return 0;
}

int abs(int x) {
    return ( x > 0 ? x : -x);
}

int max(int a, int b) {
    return (a > b ? a : b);
}

int min(int a, int b) {
    return (a < b ? a : b);
}

int cmptwry(TTower *t1, TTower *t2) {
    if ( t1->y < t2->y )
       return -1;
    if ( t1->y > t2->y )
       return 1;
    return 0;
}

void print_all() {
     int i;
     for ( i = 0; i < ct; ++i );
//         printf("%.2f %.2f %.2f\n", ts[i].x, ts[i].y, ts[i].r);
}

float dis(int i, int j) {
    return (float)sqrt((ts[i].x - ts[j].x)*(ts[i].x - ts[j].x) + (ts[i].y - ts[j].y)*(ts[i].y - ts[j].y));
}

float ci(int i) {
      float r = PI * ts[i].r * ts[i].a / 180;
      return ( r > 0 ? r : -r );
}

float angle(int x, int y) {
      float xx = ts[x].x - ts[y].x;
      if ( xx )
         return acos(dis(x, y)/xx);
      else
          return 180;
}

void angles() {
     int i;
     float a;
     for ( i = 0; i < ct; ++i ) {
         a = abs((angle(i, ts[i].c1)) + (angle(i, ts[i].c2)));
         ts[i].a = min(a, 360 - a);
     }
}

void scon(int x, int y) {
     ts[x].c1 = y;
     ts[y].c1 = x;
}

int is_up(int a, int x, int y) {
    if ( ts[x].y < ts[y].y ) {
       return ( ts[a].x - ts[a].y >= ts[x].x - ts[y].y );
    }
    else
        return ( ts[a].x + ts[a].y <= ts[x].x + ts[x].y );
}

int is_under(int a, int x, int y) {
    if ( ts[x].y < ts[y].y ) {
       return ( ts[a].x - ts[a].y <= ts[x].x - ts[y].y );
    }
    else
        return ( ts[a].x + ts[a].y >= ts[x].x + ts[x].y );
}

void conct(int x, int y, int u) {
     int i;

     ts[x].i = ts[y].i = 1;
     for ( i = 0; i < ct; ++i ) {
         if ( ts[i].i )
            continue;
         if ( u ) {
            if ( is_up(i, x, y) ) {
               conct(x, i, u);
               conct(y, i, u);
            }
            else {
                 if ( ts[x].c1 == -1 )
                    ts[x].c1 = y;
                 else
                     ts[y].c2 = y;
                 if ( ts[y].c1 == -1 )
                    ts[y].c1 = x;
                 else
                     ts[y].c2 = x;
            }
         }
         else {
              if ( is_under(i, x, y) ) {
                 conct(i, x, u);
                 conct(i, y, u);
              }
              else {
                 if ( ts[x].c1 == -1 )
                    ts[x].c1 = y;
                 else
                     ts[y].c2 = y;
                 if ( ts[y].c1 == -1 )
                    ts[y].c1 = x;
                 else
                     ts[y].c2 = x;
              }
         }
     }
}

int main() {
    float x, y, r;
    int i;

    fin = fopen("fence.inp", "r");
    fout = fopen("fence.out", "w");

    while(fscanf(fin, "%f%f%f", &x, &y, &r) != -1) {
        ts[ct].x = x;
        ts[ct].y = y;
        ts[ct++].r = r;
    }

    for ( i = 0; i < ct; ++i )
        ts[i].c1 = ts[i].c2 = -1;

    if ( ct == 2 ) {
       ts[0].a = ts[1].a = 180;
       fprintf(fout, "%.2f\n", dis(0, 1) * 2 + ci(0) + ci(1));
    }
    else if ( ct == 3 ) {
         ts[0].c1 = 1;
         ts[0].c2 = 2;
         ts[1].c1 = 0;
         ts[1].c2 = 2;
         ts[2].c1 = 0;
         ts[2].c2 = 1;
         angles();
         fprintf(fout, "%.2f\n", dis(0, 1) + dis(0, 2) + dis(1, 2) + ci(0) + ci(1) + ci(2));
    }
    else {
         int t1, t2, b1, b2, l1, l2, r1, r2, t;
         float r;

         t1 = 0;
         for ( i = 1; i < ct; ++i ) {
             if ( ts[i].y < ts[t1].y )
                t1 = i;
         }
         if ( t1 == 0 )
            t2 = 1;
         else
             t2 = 0;
         for ( i = 0; i < ct; ++i )
             if ( i != t1 && ts[i].y < ts[t2].y )
                t2 = i;
         b1 = 0;
         for ( i = 1; i < ct; ++i ) {
             if ( ts[i].y > ts[b1].y )
                b1 = i;
         }
         if ( b1 == 0 )
            b2 = 1;
         else
             b2 = 0;
         for ( i = 0; i < ct; ++i )
             if ( i != b1 && ts[i].y > ts[b2].y )
                b2 = i;
         l1 = 0;
         for ( i = 1; i < ct; ++i ) {
             if ( ts[i].x < ts[l1].x )
                l1 = i;
         }
         if ( l1 == 0 )
            l2 = 1;
         else
             l2 = 0;
         for ( i = 0; i < ct; ++i )
             if ( i != l1 && ts[i].x < ts[l2].x )
                l2 = i;
         r1 = 0;
         for ( i = 1; i < ct; ++i ) {
             if ( ts[i].x > ts[r1].x )
                r1 = i;
         }
         if ( r1 == 0 )
            r2 = 1;
         else
             r2 = 0;
         for ( i = 0; i < ct; ++i )
             if ( i != r1 && ts[i].x > ts[r2].x )
                r2 = i;
         scon(t1, t2);
         scon(b1, b2);
         scon(l1, l2);
         scon(r1, r2);
         if ( ts[t1].x > ts[t2].x ) {
            t = t1;
            t1 = t2;
            t2 = t;
         }
         if ( ts[b1].x > ts[b2].x ) {
            t = b1;
            b1 = b2;
            b2 = t;
         }
         if ( ts[l1].y > ts[l2].y ) {
            t = l1;
            l1 = l2;
            l2 = t;
         }
         if ( ts[r1].y > ts[r2].y ) {
            t = r1;
            r1 = r2;
            r2 = t;
         }
         if ( t1 != l1 )
            conct(t1, l1, 1);
         if ( t2 != r1 )
            conct(t2, r1, 1);
         if ( b1 != l2 )
            conct(b1, l2, 0);
         if ( b2 != r2)
            conct(b2, r2, 0);
         angles();
         r = 0;
         for ( i = 0; i < ct; ++i ) {
             if ( ts[i].i && ts[i].c1 > i )
                r += dis(i, ts[i].c1);
             if ( ts[i].i && ts[i].c2 > i )
                r += dis(i, ts[i].c2);
             r += ci(i);
         }
         fprintf(fout, "%.2f", 2*r);
    }

    fclose(fin);
    fclose(fout);
    return 0;
}
