{$MODE objfpc}
{$H-}

Uses
  Math;

Const
  MaxDtl = {127}1024;

Type
  Float = Extended;
  TPoint = Record
    X, Y : Single;
  End;

Var
  N : Integer;
  Point : Array[0..1000*MaxDtl+1] Of TPoint;
  Orig : Array[0..1000*MaxDtl+1] Of Integer;
  Q : Array[0..1000*MaxDtl+1] Of Integer;
  V : Array[0..1000*MaxDtl+1] Of Boolean;
  QNum : Integer;
  PointNum, PointNum2 : Integer;
  Tow : Array[0..1001] Of Record
    X, Y, R : Float;
  End;
  Path : Array[0..1001] Of Integer;
  PathLen : Integer;
  Res : Float;
  CPI : Float;
  Dtl : Integer;

Operator > (a, b : TPoint) res : Boolean;

Begin
  res := (a.X > b.X) Or ((a.X = b.X) And (a.Y > b.Y));
End;

Procedure Heapify(Q : Integer);

Var
  tmpP : TPoint;
  tmp : Integer;
  L, R : Integer;

Begin
{  Writeln(Q);}
  While Q <= (PointNum2 Shr 1) Do
  Begin
    L := Q Shl 1;
    R := L + 1;
    If R <= PointNum2 Then
    Begin
      If (Point[Q] > Point[L]) And (Point[Q] > Point[R]) Then
        Exit;
      If Point[L] > Point[R] Then
      Begin
        tmp := Orig[Q];
        Orig[Q] := Orig[L];
        Orig[L] := tmp;

        tmpP := Point[Q];
        Point[Q] := Point[L];
        Point[L] := tmpP;

        Q := L;
      End
      Else
      Begin
        tmp := Orig[Q];
        Orig[Q] := Orig[R];
        Orig[R] := tmp;

        tmpP := Point[Q];
        Point[Q] := Point[R];
        Point[R] := tmpP;

        Q := R;
      End;
    End
    Else
    Begin
      If Point[Q] > Point[L] Then
        Exit
      Else
      Begin
        tmp := Orig[Q];
        Orig[Q] := Orig[L];
        Orig[L] := tmp;

        tmpP := Point[Q];
        Point[Q] := Point[L];
        Point[L] := tmpP;

        Q := L;
      End;
    End;
  End;
End;

Procedure HeapSort;

Var
  tmp : Integer;
  tmpP : TPoint;
  I : Integer;

Begin
{  Writeln('hs');}
  PointNum2 := PointNum;
  For I := PointNum2 Div 2 DownTo 1 Do
    Heapify(I);

  For I := PointNum DownTo 2 Do
  Begin
    tmp := Orig[1];
    Orig[1] := Orig[I];
    Orig[I] := tmp;

    tmpP := Point[1];
    Point[1] := Point[I];
    Point[I] := tmpP;

    Dec(PointNum2);
    Heapify(1);
  End;
{  Writeln('/hs');}
End;

Procedure ReadIn;

Var
  F : Text;

Begin
  ASSign(F, 'fence.inp');
  Reset(F);
  N := 0;
  While Not EoF(F) Do
  Begin
    Inc(N);
    Readln(F, Tow[N].X, Tow[N].Y, Tow[N].R);
  End;
  Close(F);
End;

Procedure Gen;

Var
  I, J : Integer;
  Angle : Float;
  CosA, SinA : Float;

Begin
//  Dtl := {MaxDtl}100; {1000 -> 100; 1 -> 1024}
  {N0    -> 1024}
  {N1000 -> 100}
  Dtl := 1024 - N * (1024 - 100) Div 1000;
{  Writeln(Dtl);}
{  Writeln('gen');}
  PointNum := 0;
  For I := 0 To Dtl - 1 Do
  Begin
    Angle := I * 2 * CPI / Dtl;
    CosA := Cos(Angle);
    SinA := Sin(Angle);
    For J := 1 To N Do
    Begin
      Inc(PointNum);
      Orig[PointNum] := J;
      With Point[PointNum] Do
      Begin
        X := CosA * Tow[J].R + Tow[J].X;
        Y := SinA * Tow[J].R + Tow[J].Y;
      End;
    End;
  End;
{  Writeln('/gen');}
End;

Procedure RandGen;

Var
  I : Integer;

Begin
{  Writeln('randgen');}
  Randomize;
  N := 1000;
  For I := 1 To N Do
    With Tow[I] Do
    Begin
      X := Random(1000);
      Y := Random(1000);
      R := Random(1000);
    End;
{  Writeln('/randgen');}
End;

Function Dir(Const P1, P2, P3 : TPoint) : Float;

Begin
  Dir := (P2.X - P1.X) * (P2.Y + P1.Y) +
         (P3.X - P2.X) * (P3.Y + P2.Y) +
         (P1.X - P3.X) * (P1.Y + P3.Y);
{  Writeln(Dir);}
End;

Procedure CH;

Var
  I : Integer;

Begin
  FillChar(V[1], PointNum, 0);
  V[1] := True;
  V[2] := True;
  Q[1] := 1;
  Q[2] := 2;
  QNum := 2;
  For I := 1 To PointNum Do
  Begin
    If Not V[I] Then
    Begin
      Inc(QNum);
      V[I] := True;
      Q[QNum] := I;
    End;
    While (QNum > 2) And (Dir(Point[Q[QNum - 2]], Point[Q[QNum - 1]], Point[Q[QNum]]) <= 0) Do
    Begin
      V[Q[QNum - 1]] := False;
      Q[QNum - 1] := Q[QNum];
      Dec(QNum);
    End;
  End;
  For I := PointNum DownTo 1 Do
  Begin
    If Not V[I] Then
    Begin
      Inc(QNum);
      V[I] := True;
      Q[QNum] := I;
    End;
    While (QNum > 2) And (Dir(Point[Q[QNum - 2]], Point[Q[QNum - 1]], Point[Q[QNum]]) <= 0) Do
    Begin
      V[Q[QNum - 1]] := False;
      Q[QNum - 1] := Q[QNum];
      Dec(QNum);
    End;
  End;

  Inc(QNum);
  Q[QNum] := 1;

  PathLen := 1;
  Path[1] := Orig[Q[1]];
  For I := 2 To QNum Do
  Begin
    If Orig[Q[I]] <> Path[PathLen] Then
    Begin
      Inc(PathLen);
      Path[PathLen] := Orig[Q[I]];
    End;
  End;
End;

Function dAngle(A1, A2, R : Float) : Float;

Begin
{  Writeln(A1:0:5, ' ', A2:0:5, ' ', R:0:5);}
  While A1 < A2 Do
    A1 += 2 * CPI;
  dAngle := (A1 - A2) * R;
End;

Procedure Bahur;

Var
  I : Integer;
  A, B : Integer;
  X1, Y1, X2, Y2, R1, R2 : Float;
  vx, vy : Float;
  D : Float;
  dR, SqrdR : Float;
  SqrD : Float;
  Angle, FirstAngle, OldAngle : Float;

Begin
  Res := 0;
  For I := 1 To PathLen - 1 Do
  Begin
    A := Path[I];
    B := Path[I + 1];
    X1 := Tow[A].X;
    Y1 := Tow[A].Y;
    R1 := Tow[A].R;
    X2 := Tow[B].X;
    Y2 := Tow[B].Y;
    R2 := Tow[B].R;

    SqrD := Sqr(X1 - X2) + Sqr(Y1 - Y2);
    D := Sqrt(SqrD);

    dR := Abs(R1 - R2);
    SqrdR := dR * dR;

    Res += Sqrt(SqrD - SqrdR);

    vx := (X2 - X1)/D;
    vy := (Y2 - Y1){/D};

    If vx > 1 Then
      vx := 1
    Else
      If vx < -1 Then
        vx := -1;

    Angle := arccos(vx);
    If vy < 0 Then
    Begin
      Angle := (2 * CPI) - Angle;
    End;
    Angle -= arccos(dR / d);
    While Angle < 0 Do
      Angle += 2 * CPI;
    While Angle > 2 * CPI Do
      Angle -= 2 * CPI;

    If I <> 1 Then
      Res += dAngle(OldAngle, Angle, R1)
    Else
      FirstAngle := Angle;
    OldAngle := Angle;
  End;
  Res += dAngle(Angle, FirstAngle, Tow[Path[1]].R);
End;

Procedure WriteOut;

Var
  F : Text;

Begin
  ASSign(F, 'fence.out');
  Rewrite(F);
  Writeln(F, Res:0:2);
  Close(F);
End;

{Procedure CheckHS;

Var
  I : Integer;

Begin
  For I := 1 To PointNum - 1 Do
    If Point[I] > Point[I + 1] Then
      Writeln('bug!');
End;}

Begin
  CPI := Pi;
  ReadIn;
{  RandGen;}
  Gen;
  HeapSort;
{  CheckHS;}
  CH;
  Bahur;
  WriteOut;
End.